﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public static class GameConfig
{
    public static bool Chance(float percent)
    {
        float rnd = Random.Range(0.0f, 100.0f);
        return rnd < percent;
    }

    public static int min_satisfcation = 0;
    public static int neutral_satisfcation = 50;
    public static int max_satisfcation = 500;
    public static float new_quest_probability = 7.0f;

    public static int intial_npcs_count = 4;

    public static bool IsAddTenant(int current_satisfaction) {
        // Don't add if park is unhappy.
        if (current_satisfaction < neutral_satisfcation) return false;
        return Chance((current_satisfaction - neutral_satisfcation) * 1.0f / (max_satisfcation - neutral_satisfcation) * 30);
    }

    public static bool IsRemoveTenant(int current_satisfaction) {
        // Don't remove if park is happy.
        if (current_satisfaction > neutral_satisfcation) return false;
        return Chance((neutral_satisfcation - current_satisfaction) * 1.0f / (neutral_satisfcation - min_satisfcation) * 10);
    }

    public static string ShopItemNameConvert(string non_human_version) {
        switch (non_human_version)
        {
            case "Batteries":
                return "Batteries";
            case "Computer":
                return "Computer";
            case "Doorlock":
                return "Door Lock";
            case "Drill":
                return "Drill";
            case "Ducktape":
                return "Ducktape";
            case "Gear":
                return "Gear";
            case "Gloves":
                return "Gloves";
            case "Hammer":
                return "Hammer";
            case "Lightbulb":
                return "Lightbulb";
            case "Nails":
                return "Nails";
            case "Plunger":
                return "Plunger";
            case "Sattelite":
                return "Sattelite";
            case "Scissors":
                return "Scissors";
            case "Screwdriver":
                return "Screwdriver";
            case "Screws":
                return "Screws";
            case "Shower":
                return "Shower Head";
            case "Waterpipes":
                return "Water Pipes";
            case "Wrench":
                return "Wrench";
        }
        Debug.Log("Missing item: " + non_human_version);
        return "<not defined>";
    }
}
