﻿using System.Collections;
using System.Collections.Generic;
using RPGM.Core;
using RPGM.Gameplay;
using RPGM.UI;
using TMPro;
using UnityEngine;

namespace RPGM.UI
{
    public class ShopController : MonoBehaviour
    {
        public Transform elementPrototype;
        public GameObject InventoryPrefab;
        public float stepSizeX = 5.0f * 0.8f;
        public float stepSizeY = 0.75f * 0.8f;
        public int itemsCount = 0;
        Vector2 firstItem;
        GameModel model = Schedule.GetModel<GameModel>();
        SpriteUIElement sizer;
        public int selectedButton = 0;

        public string selectedProduct = "";

        private int posx = 0;
        private int posy = 0;
        private bool is_loaded = false;

        SpriteShopButton[] buttons = null;
        //Dictionary<(int, int), SpriteShopButton> buttons = new Dictionary<(int, int), SpriteShopButton>;
        void Start()
        {
            firstItem = elementPrototype.localPosition;
            elementPrototype.gameObject.SetActive(false);
            sizer = GetComponent<SpriteUIElement>();
            Refresh();
        }

        // Update is called once per frame
        public void Refresh()
        {
            /*if (IsLoaded()) {
//                Show();
                FocusButton(0, 0);
                return;
            }*/
            var cursor = firstItem;
            var initialCursor = firstItem;
            for (var i = 1; i < transform.childCount; i++)
                Destroy(transform.GetChild(i).gameObject);
            var displayCount = 0;
            foreach (var i in model.ShopItems)
            {
                var count = model.GetShopCount(i);
                if (count <= 0) continue;
                displayCount++;
                var e = Instantiate(elementPrototype);
                e.transform.parent = transform;
                e.transform.localPosition = cursor;
                e.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = model.GetInventorySprite(i);
                //it's not working but don't worry. we have time to fix it :)
                e.transform.localScale = new Vector3(0.8f,0.8f,0.8f);
                e.transform.GetChild(1).GetComponent<TextMeshPro>().text = $"{model.GetShopName(i)} ${model.GetShopPrice(i)} ({model.GetShopCount(i)})";
                e.transform.name = model.GetShopName(i);
                e.gameObject.SetActive(true);
                cursor.y -= stepSizeY;
                if (displayCount % 6 == 0) {
                    cursor.y = initialCursor.y;
                    cursor.x += stepSizeX;
                }
            }
            itemsCount = displayCount;
            if (displayCount > 0)
                sizer.Show();
            else
                sizer.Hide();
            // if (buttons == null) buttons = UnityEngine.Object.FindObjectsOfType<SpriteShopButton>();
            // is_loaded = true;
            FocusButton(0, 0);
        }

        public bool IsLoaded() {
            return is_loaded;
        }

        public void SetLoaded() {
            is_loaded = true;
        }

        public int Normalize(int pos, int lower, int upper){
            if (pos < lower) return lower;
            if (pos > upper) return upper;
            return pos;
        }

        public void FocusButton(int direction_x, int direction_y)
        {
            var e = Instantiate(elementPrototype);
            e.transform.parent = transform;
            int shift = direction_x * 6 + direction_y;
            posx += direction_x;
            posy += direction_y;
            posx = Normalize(posx, 0, 2);
            posy = Normalize(posy, 0, 5);
            buttons = UnityEngine.Object.FindObjectsOfType<SpriteShopButton>();
            if (selectedButton >= 0 && selectedButton < buttons.Length) buttons[selectedButton].Exit();
            selectedButton = posx * 6 + posy;
            if (itemsCount > 0)
            {
                if (buttons == null) return;
                if (selectedButton < 0 || selectedButton >= buttons.Length) return;
                // if (selectedButton < 0) selectedButton = 0;
                // if (selectedButton >= buttons.Length) selectedButton = buttons.Length;
                // Debug.Log(buttons.Length);
                // buttons[selectedButton].Exit();
                // selectedButton += shift;
                // selectedButton = Mathf.Clamp(selectedButton, 0, itemsCount - 1);
                // Debug.Log(buttons.Length + " ??? " + selectedButton);
                selectedProduct = buttons[selectedButton].name;
                buttons[selectedButton].Enter();
            }
        }

        public void SelectActiveButton()
        {
            if (itemsCount > 0)
            {
                if (selectedButton >= 0)
                {
                    // model.input.ChangeState(InputController.State.CharacterControl);
                    buttons[selectedButton].Click();
                    model.BuyShopItem(buttons[selectedButton].name,1);
                    // selectedButton = -1;
                    FocusButton(0, 0);
                }
            }
            else
            {
                //there are no buttons, just Hide when required.
                model.input.ChangeState(InputController.State.CharacterControl);
                Hide();
            }
        }

        public void Hide()
        {
            UserInterfaceAudio.OnHideDialog();
            model.input.ChangeState(InputController.State.CharacterControl);
            gameObject.SetActive(false);
        }

        public void Show()
        {
            sizer.Show();
            gameObject.SetActive(true);
            model.input.ChangeState(InputController.State.ShopControl);
        }
        
    }
}